#ifndef _NETPKT_UTILS_H_
#define _NETPKT_UTILS_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#ifdef HAVE_SYS_SOCKIO_H
#include <sys/sockio.h>
#endif /* HAVE_SYS_SOCKIO_H */
#include <sys/errno.h>
#include <sys/queue.h>

#include <netinet/in.h>
#include <net/if.h>
#include <arpa/inet.h>

#define STDIN_FD       0
#define STDOUT_FD      1
#define STDERR_FD      2

#define pkt_bufsize    64000
#define pkt_mtu        1460

//#define DEBUG_LVL      0x00FF
//#define DEBUG_LVL      0x0041
#define DEBUG_LVL      0x0000
  
#define DEBUG_ERRORS   0x0001  // Errors only
#define DEBUG_INIT     0x0002  // Initialization
#define DEBUG_CONNS    0x0004  // Connection information
#define DEBUG_PKT      0x0010  // Noisy packet information
#define DEBUG_PKTV     0x0020  // V. Noisy packet information
#define DEBUG_TST      0x0040  // Tester information

void make_async (int s);
void close_on_exec (int s);
int  open_dgram (struct sockaddr_in *addr, u_int16_t port);
int  sendpkt    (int fd, struct sockaddr_in *to, char *buf, u_int len);
void recvpkt    (int fd);

u_short in_cksum (u_char *pkt, int len);

// ---------------------------
// Packet hdr type

#define DAT 0x0001
#define SYN 0x0002
#define ACK 0x0004
#define FIN 0x0008
#define RST 0x0010

struct reliable_hdr {
  u_int32_t seq_no;
  u_int32_t ack_no;
  u_int16_t type;
  u_int16_t chksum;
};

// ---------------------------
// Data queue


/*
 * XXX You should write some linked list structure here that stores 
 * which packets have been received to enable in-order reliable 
 * stream abstraction.
 */

// Client (sender) side
struct snd_state {
};

// Server (receiver) side
struct rcv_state {

};

// ---------------------------
// For timer

extern time_t elapsed;	   /* Number of seconds elapsed since start */
extern int want_timer;	   /* If > 0, calls once per 100 ms */

void add_fd (int fd);
void rem_fd (int fd);
void run (void) __attribute__ ((noreturn));
void setup_core ();

/* You need to implement this in clntd.c and srvd.c: */
extern void timer (void);
extern void handle_pkt (int fd, char *buf, int pktlen, struct sockaddr_in from);

#endif /* !_NETPKT_UTILS_H_ */
